Index: uspace/app/mkmfs/mkmfs.c
===================================================================
--- uspace/app/mkmfs/mkmfs.c	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/app/mkmfs/mkmfs.c	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -348,5 +348,5 @@
 	unsigned int i;
 	uint8_t *itable_buf;
-	int rc;
+	int rc = EOK;
 
 	long itable_off = sb->zbmap_blocks + sb->ibmap_blocks + 2;
@@ -633,5 +633,5 @@
 	const unsigned int zbmap_nblocks = sb->zbmap_blocks;
 	unsigned int i;
-	int rc;
+	int rc = EOK;
 
 	ibmap_buf = malloc(ibmap_nblocks * sb->block_size);
Index: uspace/app/sbi/src/os/helenos.c
===================================================================
--- uspace/app/sbi/src/os/helenos.c	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/app/sbi/src/os/helenos.c	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -155,5 +155,5 @@
 	size_t offset;
 	int i;
-	wchar_t c;
+	wchar_t c = 0;
 
 	if (index < 0)
Index: uspace/app/sbi/src/run_expr.c
===================================================================
--- uspace/app/sbi/src/run_expr.c	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/app/sbi/src/run_expr.c	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -2504,6 +2504,8 @@
 	elem_index = 0;
 
+	assert(node != NULL);
+
 	i = 0;
-	while (node != NULL) {
+	do {
 		if (i >= 1) {
 			printf("Error: Too many indices string.\n");
@@ -2527,5 +2529,5 @@
 		node = list_next(args, node);
 		i += 1;
-	}
+	} while (node != NULL);
 
 	if (i < 1) {
Index: uspace/drv/bus/pci/pciintel/pci.c
===================================================================
--- uspace/drv/bus/pci/pciintel/pci.c	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/drv/bus/pci/pciintel/pci.c	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -293,5 +293,5 @@
 	const uint32_t conf_addr = CONF_ADDR(fun->bus, fun->dev, fun->fn, reg);
 	pci_bus_t *bus = pci_bus_from_fun(fun);
-	uint32_t val;
+	uint32_t val = 0;
 	
 	fibril_mutex_lock(&bus->conf_mutex);
Index: uspace/drv/intctl/apic/apic.h
===================================================================
--- uspace/drv/intctl/apic/apic.h	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/drv/intctl/apic/apic.h	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -33,6 +33,6 @@
  */
 
-#ifndef ICP_IC_H_
-#define ICP_IC_H
+#ifndef APIC_H_
+#define APIC_H_
 
 #include <ddf/driver.h>
Index: uspace/drv/intctl/i8259/i8259.h
===================================================================
--- uspace/drv/intctl/i8259/i8259.h	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/drv/intctl/i8259/i8259.h	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -33,6 +33,6 @@
  */
 
-#ifndef ICP_IC_H_
-#define ICP_IC_H
+#ifndef I8259_H_
+#define I8259_H_
 
 #include <ddf/driver.h>
Index: uspace/drv/intctl/icp-ic/icp-ic.h
===================================================================
--- uspace/drv/intctl/icp-ic/icp-ic.h	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/drv/intctl/icp-ic/icp-ic.h	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -34,5 +34,5 @@
 
 #ifndef ICP_IC_H_
-#define ICP_IC_H
+#define ICP_IC_H_
 
 #include <ddf/driver.h>
Index: uspace/lib/bithenge/src/compound.c
===================================================================
--- uspace/lib/bithenge/src/compound.c	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/lib/bithenge/src/compound.c	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -81,5 +81,5 @@
 
 	*out = in;
-	return rc;
+	return EOK;
 }
 
Index: uspace/lib/trackmod/xm.c
===================================================================
--- uspace/lib/trackmod/xm.c	(revision ccbf93fcea0f6985664424afb80e700aecc387bf)
+++ uspace/lib/trackmod/xm.c	(revision 04649677bb4fbe5c0b699c27add4f8664d9a15fc)
@@ -289,5 +289,5 @@
 	size_t instr_size;
 	size_t smp_size;
-	size_t smp_hdr_size = 0; /* GCC false alarm on uninitialized */
+	size_t smp_hdr_size = 0;  /* GCC false alarm on uninitialized */
 	ssize_t nread;
 	uint8_t ltype;