Index: uspace/lib/posix/signal.c
===================================================================
--- uspace/lib/posix/signal.c	(revision 4419c347a4231f39281a505ad4149f3d49261123)
+++ uspace/lib/posix/signal.c	(revision 6921178cb94f16c993f442abb278dbce48fe6afe)
@@ -136,7 +136,8 @@
 }
 
-/** Just an empty function to get an unique pointer value for comparison.
- *
- * @param signo
+/**
+ * Just an empty function to get an unique pointer value for comparison.
+ *
+ * @param signo Signal number.
  */
 void __posix_hold_signal_handler(int signo)
@@ -145,7 +146,8 @@
 }
 
-/** Empty function to be used as ignoring handler.
- * 
- * @param signo
+/**
+ * Empty function to be used as ignoring handler.
+ * 
+ * @param signo Signal number.
  */
 void __posix_ignore_signal_handler(int signo)
@@ -154,5 +156,6 @@
 }
 
-/** Clear the signal set.
+/**
+ * Clear the signal set.
  * 
  * @param set Pointer to the signal set.
@@ -167,5 +170,6 @@
 }
 
-/** Fill the signal set (i.e. add all signals).
+/**
+ * Fill the signal set (i.e. add all signals).
  * 
  * @param set Pointer to the signal set.
@@ -180,5 +184,6 @@
 }
 
-/** Add a signal to the set.
+/**
+ * Add a signal to the set.
  * 
  * @param set Pointer to the signal set.
@@ -194,5 +199,6 @@
 }
 
-/** Delete a signal from the set.
+/**
+ * Delete a signal from the set.
  * 
  * @param set Pointer to the signal set.
@@ -208,5 +214,6 @@
 }
 
-/** Inclusion test for a signal set.
+/**
+ * Inclusion test for a signal set.
  * 
  * @param set Pointer to the signal set.
@@ -221,7 +228,8 @@
 }
 
-/** Unsafe variant of the sigaction() function.
- *  Doesn't do any checking of its arguments and
- *  does not deal with thread-safety.
+/**
+ * Unsafe variant of the sigaction() function.
+ * Doesn't do any checking of its arguments and
+ * does not deal with thread-safety.
  * 
  * @param sig
@@ -243,5 +251,6 @@
 }
 
-/** Sets a new action for the given signal number.
+/**
+ * Sets a new action for the given signal number.
  * 
  * @param sig Signal number to set action for.
@@ -276,5 +285,6 @@
 }
 
-/** Sets a new handler for the given signal number.
+/**
+ * Sets a new handler for the given signal number.
  * 
  * @param sig Signal number to set handler for.
@@ -304,5 +314,6 @@
 } signal_queue_item;
 
-/** Queue blocked signal.
+/**
+ * Queue blocked signal.
  *
  * @param signo Signal number.
@@ -322,5 +333,6 @@
 
 
-/** Executes an action associated with the given signal.
+/**
+ * Executes an action associated with the given signal.
  *
  * @param signo Signal number.
@@ -366,5 +378,6 @@
 }
 
-/** Raise all unblocked previously queued signals.
+/**
+ * Raise all unblocked previously queued signals.
  */
 static void _dequeue_unblocked_signals()
@@ -390,5 +403,6 @@
 }
 
-/** Raise a signal for the calling process.
+/**
+ * Raise a signal for the calling process.
  * 
  * @param sig Signal number.
@@ -409,5 +423,6 @@
 }
 
-/** Raises a signal for a selected process.
+/**
+ * Raises a signal for a selected process.
  * 
  * @param pid PID of the process for which the signal shall be raised.
@@ -446,6 +461,7 @@
 }
 
-/** Send a signal to a process group. Always fails at the moment because of
- *  lack of this functionality in HelenOS.
+/**
+ * Send a signal to a process group. Always fails at the moment because of
+ * lack of this functionality in HelenOS.
  * 
  * @param pid PID of the process group.
@@ -459,5 +475,6 @@
 }
 
-/** Outputs information about the signal to the standard error stream.
+/**
+ * Outputs information about the signal to the standard error stream.
  * 
  * @param pinfo SigInfo struct to write.
@@ -471,5 +488,6 @@
 }
 
-/** Outputs information about the signal to the standard error stream.
+/**
+ * Outputs information about the signal to the standard error stream.
  * 
  * @param signum Signal number.
@@ -486,5 +504,6 @@
 }
 
-/** Manipulate the signal mask of the calling thread.
+/**
+ * Manipulate the signal mask of the calling thread.
  * 
  * @param how What to do with the mask.
@@ -525,5 +544,6 @@
 }
 
-/** Manipulate the signal mask of the process.
+/**
+ * Manipulate the signal mask of the process.
  * 
  * @param how What to do with the mask.